/*********************************************/
/* ĥ                                    */
/*                                           */
/* 1.  ó                        */
/* 2. DB ִ κ ÷                  */
/*********************************************/

/*********************************************/
/* HEAD_DECLARE								 */
/*********************************************/
#include <string.h>	// memset, strcpy
#include <stdio.h>
#include "logsave.h"

/*********************************************/
/* FMT_LOGREC - terminate log fields w/zeros */
/* seperate fields with \0's				 */
/* ' ' ĭ  ؼ /0 äִ  */
/* Լ. ", [ ] ( )  ؼ parsing  */
/* 2003.3.19 								 */
/*********************************************/
void fmt_logrec(char *buffer)
{
   char *cp=buffer;
   int  q=0,b=0,p=0;

   while (*cp != '\0')
   {
      /* break record up, terminate fields with '\0' */
      switch (*cp)
      {
       case ' ': if (b || q || p) break; *cp='\0'; break;
       case '"': q^=1;  break;
       case '[': if (q) break; b++; break;
       case ']': if (q) break; if (b>0) b--; break;
       case '(': if (q) break; p++; break;
       case ')': if (q) break; if (p>0) p--; break;
      }
      cp++;
   }
}

int main(int argc, char *argv[])
{
	FILE *fp;
	char buffer[4096];
	char *cp;
	weblog *instance;
	weblog *tmp;
	int ipcnt=1; 			//ipcnt

	/*******************************************************/
	/*  κ 켱 sample access_log  ӽ÷    */
	/*  ͼ 									   */
	/* ߿ Ŀǵ忡 Է ޴ ƴϸ			   */
	/* ȯϿ о κ   			   */
	/*******************************************************/
	if ((fp=fopen("../samplelog/logsample.log","r")) == NULL)
	{
		printf("fopen err\n");
		exit(1);
	};
	memset(buffer,0,sizeof(buffer));

	initWeblogStruct();					// ü ʱȭ

	while (fgets(buffer, 4096, fp) > 0)  // fread vs fgets
	{
		int len;
		char * str;
		fmt_logrec(buffer); 			//seperate buffer
		cp = buffer; 					// buffer's first start addr

		instance = (weblog*)malloc(sizeof(weblog));

		/*************************/
		/* weblog ü ÷  */
		/* ߿ Լȭ ų  */
		/*************************/

		/* source IP */
		str = spin_entry(cp);
		len = strlen(str);
		instance->ip=(char*)malloc(len);
		strncpy(instance->ip,str,len);
		cp = cp + len + 1;

		/* rfc1413 */
		str = spin_entry(cp);
		len = strlen(str);
		instance->rfc1413=(char*)malloc(len);
		strncpy(instance->rfc1413,str,len);
		cp = cp + len +1;

		/* user name */
		str = spin_entry(cp);
		len = strlen(str);
		instance->username=(char*)malloc(len);
		strncpy(instance->username,str,len);
		cp = cp + len +1 ;

		/* LocalTime */
		str = spin_entry(cp);
		len = strlen(str);
		instance->LocalTime=(char*)malloc(len);
		strncpy(instance->LocalTime,str,len);
		cp = cp + len + 1;

		/* httprequest */
		str = spin_entry(cp);
		len = strlen(str);
		instance->httpRequest=(char*)malloc(len);
		strncpy(instance->httpRequest,str,len);
		cp = cp + len + 1;

		/* status */
		str = spin_entry(cp);
		len = strlen(str);
		instance->status=(char*)malloc(len);
		strncpy(instance->status,str,len);
		cp = cp + len + 1;

		/* bystsenttoclient */	
		str = spin_entry(cp);
		len = strlen(str);
		instance->byteSentToClient=(char*)malloc(len);
		strncpy(instance->byteSentToClient,str,len);
		cp = cp + len + 1;

		/* referer */
		str = spin_entry(cp);
		len = strlen(str);
		instance->referer=(char*)malloc(len);
		strncpy(instance->referer,str,len);
		cp = cp + len + 1;

		/* clientsoftware */
		str = spin_entry(cp);
		len = strlen(str);
		instance->clientSoftware=(char*)malloc(len);
		strncpy(instance->clientSoftware,str,len);

		/**********************************************/
		/* ü  ִ߰ κ ߿ */
		/*  ̽ ٷ Էϴ κ     */
		/*   ʿ䰡   ϴ. 		  */
		/**********************************************/
		addStruct(instance); 				// add logdata ==> linked list

		/**********************************************/
		/* ̺κп   ڷḦ   Ŵ */
		/*      䱸 Ƚ   */
		/* ׹ۿ ϴ ڷ                         */
		/**********************************************/
//		statics(instance);					// ex)踦 ϴ  
		
	}

//	׸ ؼ  κ
	tmp=head->next;
	while(tmp != end)
	{
		printf("ip(%s) : ",tmp->ip); // ׿
		printf("time(%s) : ",tmp->LocalTime);
		printf("httpRequest(%s)\n",tmp->httpRequest); // ׿
		tmp=tmp->next;
	}
	printf("There is no remaining\n");


	/**********************************************/
	/*  strncmp  ϸ Ʈũ Ŭ     */
	/*                          */
	/**********************************************/
	/**********************************************
	tmp=head->next;
	while(tmp != end)
	{

		if ( !strncmp("210.94.164.138",tmp->ip, 10))  
		{
			printf("210.94.164.XXX ==>  %s \n", tmp->ip);
		}
		tmp=tmp->next;
	}
	************************************************/
	return 0;
}
